HDOJ 1372 Knight Moves(BFS 广搜)

题目:

Knight Moves

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 3684    Accepted Submission(s): 2293


Problem Description
A friend of you is doing research on the Traveling Knight Problem (TKP) where you are to find the shortest closed tour of knight moves that visits each square of a given set of n squares on a chessboard exactly once. He thinks that the most difficult part of the problem is determining the smallest number of knight moves between two given squares and that, once you have accomplished this, finding the tour would be easy.
Of course you know that it is vice versa. So you offer him to write a program that solves the "difficult" part.

Your job is to write a program that takes two squares a and b as input and then determines the number of knight moves on a shortest route from a to b.


 

Input
The input file will contain one or more test cases. Each test case consists of one line containing two squares separated by one space. A square is a string consisting of a letter (a-h) representing the column and a digit (1-8) representing the row on the chessboard.


 

Output
For each test case, print one line saying "To get from xx to yy takes n knight moves.".


 

Sample Input
  
  
e2 e4 a1 b2 b2 c3 a1 h8 a1 h7 h8 a1 b1 c3 f6 f6


 

Sample Output
  
  
To get from e2 to e4 takes 2 knight moves. To get from a1 to b2 takes 4 knight moves. To get from b2 to c3 takes 2 knight moves. To get from a1 to h8 takes 6 knight moves. To get from a1 to h7 takes 5 knight moves. To get from h8 to a1 takes 6 knight moves. To get from b1 to c3 takes 1 knight moves. To get from f6 to f6 takes 0 knight moves.

 

 

题目链接:

http://acm.hdu.edu.cn/showproblem.php?pid=1372

 

 

题意:

  一个8*8的正方形棋盘,行用a-h标记,列用1-8标记。

  给定两个坐标,要求你从一个坐标到另一个坐标的最小步数。

  移动和象棋中的马一样,走 “日”  字。

 

思路:

广搜8个方向

 

#include<iostream>
#include<queue>
using namespace std;

const int maxn = 10 +1;
int dir[8][2] = {-1,-2,1,-2,-1,2,1,2,-2,-1,-2,1,2,-1,2,1};
int used[maxn][maxn];
char a,b;
int x,y;


struct node
{
	int x;
	int y;
	int t;
};


void bfs()
{
	queue<node> q;
	node start;
	start.x = a - 'a' + 1;
	start.y = x;
	start.t = 0;
	q.push(start);
	used[start.x][start.y] = 1;
/*	if(a = b && x == y)
	{
		cout<<"0 knight moves."<<endl;
	}
	@@@@*/
	while(!q.empty())
	{
		node head = q.front();
		q.pop();
		if(head.x == b-'a'+1 && head.y == y)    //结束条件  因为之前在for循环里面  所以用 if(New.x == b-'a'+1 && New.y == y)  造成错误                      
		{
			cout<<head.t<<" knight moves."<<endl;
			return;
		}
		for(int i=0; i<8; i++)
		{
			node New;
			New=head;
			New.x = head.x + dir[i][0];
			New.y = head.y + dir[i][1];
			New.t = head.t + 1;			//计算走过的路径  把计数器定在结构体里面  不会造成计数重复 错误
			if(New.x>0 && New.x<=8 && New.y>0 && New.y<=8)//范围这里之前因为start.x = a - 'a' + 1;没有+1,导致范围错误(竖的从0开始,横的从1开始)
			{
				
				if(!used[New.x][New.y])
				{
			
				/*	if(New.x == b-'a'+1 && New.y == y)   
					{
						cout<<New.t<<" knight moves."<<endl;
						return;
					}*///如果是用这种做结束条件  要上面的那条语句@@@@,因为起点和终点一样的时候,在这里已经是被扩展过的所以计数为2
					used[New.x][New.y] = 1;
					q.push(New);
				
				}
			}
		
			
		}
	}
}

int main()
{
	
	while(cin>>a>>x>>b>>y)
	{
		memset(used, 0, sizeof(used));
		cout<<"To get from "<<a<<x<<" to "<<b<<y<<" takes ";
		bfs();
	}
	return 0;
}


//


 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值